<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>CppPackageHeaderGenerator xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../apidocs/org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppPackageHeaderGenerator.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.xtend;
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.common.base.GenUtils;
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.preferences.CppCodeGenUtils;
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.utils.CppGenUtils;
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.xtend.CppClassIncludeClassDeclaration;
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.xtend.CppClassTypeAndEnum;
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.xtend.CppIncludeUtil;
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <strong class="jxr_keyword">import</strong> org.eclipse.xtend2.lib.StringConcatenation;
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_javadoccomment"> * @author Önder GÜRCAN (onder.gurcan@cea.fr)</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  @SuppressWarnings(<span class="jxr_string">"all"</span>)
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppPackageHeaderGenerator.html">CppPackageHeaderGenerator</a> {
<a class="jxr_linenumber" name="L17" href="#L17">17</a>    <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> CharSequence generateCode(<strong class="jxr_keyword">final</strong> org.eclipse.uml2.uml.Package pkg) {
<a class="jxr_linenumber" name="L18" href="#L18">18</a>      StringConcatenation _builder = <strong class="jxr_keyword">new</strong> StringConcatenation();
<a class="jxr_linenumber" name="L19" href="#L19">19</a>      _builder.append(<span class="jxr_string">"#ifndef PKG_"</span>);
<a class="jxr_linenumber" name="L20" href="#L20">20</a>      String _fullNameUC = GenUtils.getFullNameUC(pkg);
<a class="jxr_linenumber" name="L21" href="#L21">21</a>      _builder.append(_fullNameUC, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L22" href="#L22">22</a>      _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L23" href="#L23">23</a>      _builder.append(<span class="jxr_string">"#define PKG_"</span>);
<a class="jxr_linenumber" name="L24" href="#L24">24</a>      String _fullNameUC_1 = GenUtils.getFullNameUC(pkg);
<a class="jxr_linenumber" name="L25" href="#L25">25</a>      _builder.append(_fullNameUC_1, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L26" href="#L26">26</a>      _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L27" href="#L27">27</a>      _builder.newLine();
<a class="jxr_linenumber" name="L28" href="#L28">28</a>      _builder.append(<span class="jxr_string">"/************************************************************"</span>);
<a class="jxr_linenumber" name="L29" href="#L29">29</a>      _builder.newLine();
<a class="jxr_linenumber" name="L30" href="#L30">30</a>      _builder.append(<span class="jxr_string">"              "</span>);
<a class="jxr_linenumber" name="L31" href="#L31">31</a>      _builder.append(<span class="jxr_string">"Pkg_"</span>);
<a class="jxr_linenumber" name="L32" href="#L32">32</a>      String _name = pkg.getName();
<a class="jxr_linenumber" name="L33" href="#L33">33</a>      _builder.append(_name, <span class="jxr_string">"              "</span>);
<a class="jxr_linenumber" name="L34" href="#L34">34</a>      _builder.append(<span class="jxr_string">" package header"</span>);
<a class="jxr_linenumber" name="L35" href="#L35">35</a>      _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L36" href="#L36">36</a>      _builder.append(<span class="jxr_string">" "</span>);
<a class="jxr_linenumber" name="L37" href="#L37">37</a>      _builder.append(<span class="jxr_string">"************************************************************/"</span>);
<a class="jxr_linenumber" name="L38" href="#L38">38</a>      _builder.newLine();
<a class="jxr_linenumber" name="L39" href="#L39">39</a>      _builder.newLine();
<a class="jxr_linenumber" name="L40" href="#L40">40</a>      org.eclipse.uml2.uml.Package _nestingPackage = pkg.getNestingPackage();
<a class="jxr_linenumber" name="L41" href="#L41">41</a>      String _cppOwnerPackageIncludePath = CppClassIncludeClassDeclaration.cppOwnerPackageIncludePath(_nestingPackage);
<a class="jxr_linenumber" name="L42" href="#L42">42</a>      String _includeDirective = CppIncludeUtil.includeDirective(_cppOwnerPackageIncludePath);
<a class="jxr_linenumber" name="L43" href="#L43">43</a>      _builder.append(_includeDirective, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L44" href="#L44">44</a>      _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L45" href="#L45">45</a>      _builder.newLine();
<a class="jxr_linenumber" name="L46" href="#L46">46</a>      _builder.append(<span class="jxr_string">"#ifndef _IN_"</span>);
<a class="jxr_linenumber" name="L47" href="#L47">47</a>      _builder.newLine();
<a class="jxr_linenumber" name="L48" href="#L48">48</a>      _builder.append(<span class="jxr_string">"#define _IN_"</span>);
<a class="jxr_linenumber" name="L49" href="#L49">49</a>      _builder.newLine();
<a class="jxr_linenumber" name="L50" href="#L50">50</a>      _builder.append(<span class="jxr_string">"#endif"</span>);
<a class="jxr_linenumber" name="L51" href="#L51">51</a>      _builder.newLine();
<a class="jxr_linenumber" name="L52" href="#L52">52</a>      _builder.append(<span class="jxr_string">"#ifndef _OUT_"</span>);
<a class="jxr_linenumber" name="L53" href="#L53">53</a>      _builder.newLine();
<a class="jxr_linenumber" name="L54" href="#L54">54</a>      _builder.append(<span class="jxr_string">"#define _OUT_"</span>);
<a class="jxr_linenumber" name="L55" href="#L55">55</a>      _builder.newLine();
<a class="jxr_linenumber" name="L56" href="#L56">56</a>      _builder.append(<span class="jxr_string">"#endif"</span>);
<a class="jxr_linenumber" name="L57" href="#L57">57</a>      _builder.newLine();
<a class="jxr_linenumber" name="L58" href="#L58">58</a>      _builder.append(<span class="jxr_string">"#ifndef _INOUT_"</span>);
<a class="jxr_linenumber" name="L59" href="#L59">59</a>      _builder.newLine();
<a class="jxr_linenumber" name="L60" href="#L60">60</a>      _builder.append(<span class="jxr_string">"#define _INOUT_"</span>);
<a class="jxr_linenumber" name="L61" href="#L61">61</a>      _builder.newLine();
<a class="jxr_linenumber" name="L62" href="#L62">62</a>      _builder.append(<span class="jxr_string">"#endif"</span>);
<a class="jxr_linenumber" name="L63" href="#L63">63</a>      _builder.newLine();
<a class="jxr_linenumber" name="L64" href="#L64">64</a>      _builder.newLine();
<a class="jxr_linenumber" name="L65" href="#L65">65</a>      _builder.append(<span class="jxr_string">"\t"</span>);
<a class="jxr_linenumber" name="L66" href="#L66">66</a>      _builder.newLine();
<a class="jxr_linenumber" name="L67" href="#L67">67</a>      _builder.append(<span class="jxr_string">"/* Package dependency header include                        */"</span>);
<a class="jxr_linenumber" name="L68" href="#L68">68</a>      _builder.newLine();
<a class="jxr_linenumber" name="L69" href="#L69">69</a>      {
<a class="jxr_linenumber" name="L70" href="#L70">70</a>        EList&lt;org.eclipse.uml2.uml.Package&gt; _usedPackages = GenUtils.getUsedPackages(pkg);
<a class="jxr_linenumber" name="L71" href="#L71">71</a>        <strong class="jxr_keyword">for</strong>(<strong class="jxr_keyword">final</strong> org.eclipse.uml2.uml.Package p : _usedPackages) {
<a class="jxr_linenumber" name="L72" href="#L72">72</a>          String _fullPath = GenUtils.getFullPath(p);
<a class="jxr_linenumber" name="L73" href="#L73">73</a>          String _plus = (_fullPath + <span class="jxr_string">"/Pkg_"</span>);
<a class="jxr_linenumber" name="L74" href="#L74">74</a>          String _name_1 = p.getName();
<a class="jxr_linenumber" name="L75" href="#L75">75</a>          String _plus_1 = (_plus + _name_1);
<a class="jxr_linenumber" name="L76" href="#L76">76</a>          String _plus_2 = (_plus_1 + <span class="jxr_string">"."</span>);
<a class="jxr_linenumber" name="L77" href="#L77">77</a>          String _headerSuffix = CppCodeGenUtils.getHeaderSuffix();
<a class="jxr_linenumber" name="L78" href="#L78">78</a>          String path = (_plus_2 + _headerSuffix);
<a class="jxr_linenumber" name="L79" href="#L79">79</a>          _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L80" href="#L80">80</a>          String _includeDirective_1 = CppIncludeUtil.includeDirective(path);
<a class="jxr_linenumber" name="L81" href="#L81">81</a>          _builder.append(_includeDirective_1, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L82" href="#L82">82</a>          _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L83" href="#L83">83</a>        }
<a class="jxr_linenumber" name="L84" href="#L84">84</a>      }
<a class="jxr_linenumber" name="L85" href="#L85">85</a>      _builder.newLine();
<a class="jxr_linenumber" name="L86" href="#L86">86</a>      String _CppIncludeHeader = CppIncludeUtil.CppIncludeHeader(pkg);
<a class="jxr_linenumber" name="L87" href="#L87">87</a>      _builder.append(_CppIncludeHeader, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L88" href="#L88">88</a>      _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L89" href="#L89">89</a>      String _openNS = CppGenUtils.openNS(pkg);
<a class="jxr_linenumber" name="L90" href="#L90">90</a>      _builder.append(_openNS, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L91" href="#L91">91</a>      _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L92" href="#L92">92</a>      _builder.newLine();
<a class="jxr_linenumber" name="L93" href="#L93">93</a>      _builder.append(<span class="jxr_string">"// Types defined within the package"</span>);
<a class="jxr_linenumber" name="L94" href="#L94">94</a>      _builder.newLine();
<a class="jxr_linenumber" name="L95" href="#L95">95</a>      CharSequence _CppClassTypeAndEnumPackage = CppClassTypeAndEnum.CppClassTypeAndEnumPackage(pkg);
<a class="jxr_linenumber" name="L96" href="#L96">96</a>      _builder.append(_CppClassTypeAndEnumPackage, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L97" href="#L97">97</a>      _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L98" href="#L98">98</a>      String _closeNS = CppGenUtils.closeNS(pkg);
<a class="jxr_linenumber" name="L99" href="#L99">99</a>      _builder.append(_closeNS, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L100" href="#L100">100</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L101" href="#L101">101</a>     _builder.newLine();
<a class="jxr_linenumber" name="L102" href="#L102">102</a>     _builder.append(<span class="jxr_string">"/************************************************************"</span>);
<a class="jxr_linenumber" name="L103" href="#L103">103</a>     _builder.newLine();
<a class="jxr_linenumber" name="L104" href="#L104">104</a>     _builder.append(<span class="jxr_string">"              "</span>);
<a class="jxr_linenumber" name="L105" href="#L105">105</a>     _builder.append(<span class="jxr_string">"End of Pkg_"</span>);
<a class="jxr_linenumber" name="L106" href="#L106">106</a>     String _name_2 = pkg.getName();
<a class="jxr_linenumber" name="L107" href="#L107">107</a>     _builder.append(_name_2, <span class="jxr_string">"              "</span>);
<a class="jxr_linenumber" name="L108" href="#L108">108</a>     _builder.append(<span class="jxr_string">" package header"</span>);
<a class="jxr_linenumber" name="L109" href="#L109">109</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L110" href="#L110">110</a>     _builder.append(<span class="jxr_string">" "</span>);
<a class="jxr_linenumber" name="L111" href="#L111">111</a>     _builder.append(<span class="jxr_string">"************************************************************/"</span>);
<a class="jxr_linenumber" name="L112" href="#L112">112</a>     _builder.newLine();
<a class="jxr_linenumber" name="L113" href="#L113">113</a>     _builder.newLine();
<a class="jxr_linenumber" name="L114" href="#L114">114</a>     _builder.append(<span class="jxr_string">"#endif"</span>);
<a class="jxr_linenumber" name="L115" href="#L115">115</a>     _builder.newLine();
<a class="jxr_linenumber" name="L116" href="#L116">116</a>     <strong class="jxr_keyword">return</strong> _builder;
<a class="jxr_linenumber" name="L117" href="#L117">117</a>   }
<a class="jxr_linenumber" name="L118" href="#L118">118</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
